<?php

/**
 * @link       https://www.suments.com
 * @since      1.0.0
 *
 * @package    Metawash 
 * @author     Suments Data <hola@metawash.me>
 */
class METAWASH_Admin
{

	private $Metawash;
	
	private $version;
	private $totalFiles, $convertedFiles;
	private $S_URL_PREFIX = "https://api.metawash.me/api";
	private $S_URL_POST = "";
	private $S_URL_TARGET = "";
	private $S_URL_HOST = "";

	private $S_PATH_TOKEN = "";
	private $S_PATH_FT = "";
	private $S_PATH_VERSION = "";
	private $S_PATH_LOGS = "";
	private $S_PATH_LOGS_ERRORS_STREAMS = "";

	private $S_PATH_CONFIG_AUTO = "";


	public function __construct($Metawash, $version)
	{

		$this->Metawash = $Metawash;
		$this->version = $version;

		$this->S_PATH_TOKEN =  plugin_dir_path( __DIR__ ).'config/token.suments';
		$this->S_PATH_FT =  plugin_dir_path( __DIR__ ).'config/ft.suments';
		$this->S_PATH_VERSION = plugin_dir_path( __DIR__ ).'config/version.suments';
		$this->S_PATH_LOGS = plugin_dir_path( __DIR__ ).'logs/last.log';
		$this->S_PATH_LOGS_ERRORS_STREAMS = plugin_dir_path( __DIR__ ).'logs/error_stream.log';

		$this->S_PATH_CONFIG_AUTO =  plugin_dir_path( __DIR__ ).'config/auto.suments';
	}


	public function enqueue_styles()
	{


		wp_enqueue_style($this->Metawash, plugin_dir_url(__FILE__) . 'css/metawash-admin.css', array(), $this->version, 'all');
		//wp_enqueue_style( $this->Metawash, plugin_dir_url( __FILE__ ) . 'css/styles.css', array(), $this->version, 'all' );
		wp_enqueue_style( $this->Metawash, plugin_dir_url( __FILE__ ) . 'https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css', array(), $this->version, 'all' );
	}


	public function enqueue_scripts()
	{

		wp_enqueue_script($this->Metawash, plugin_dir_url(__FILE__) . 'js/metawash-admin.js', array('jquery'), $this->version, false);
		wp_localize_script($this->Metawash, 'myAjax', array('ajaxurl' => admin_url('admin-ajax.php')));
	}

	public function dirFileCon_options_page()
	{
		add_menu_page(
			'meta-wash',
			'Metawash',
			'manage_options',
			'dfcon',
			array($this, 'directoryFileOptionPage'),
			plugin_dir_url( __FILE__ ).'/img/dash-icon-16x16.png'

		);
	}

	public function directoryFileOptionPage()
	{ ?>
	<?php 
		if($this->s_token_get() != ""){
			$this->s_token_validate($this->s_token_get());
		}
		$this->s_ft_update();
		
		$feedback_user["token_information"] = $this->s_token_validate();
	?>
<table
    style="width:100%;max-width:1000px;border:none;border-spacing:0;text-align:left;font-family:Arial,sans-serif;line-height:22px;align:center;">
    <tr style="align:center;padding:0px;">
        <td style="align:center;padding:0px;" class="tabletext">
            <div class="row">
                <div class="column" style="width:100%;margin:20px;">
                    <!-- FUNCIONALIDAD -->
                    <div class="card-mc">
                        <div class="container">
                            <div class="logo-wrap">
                                <br>
                                <a href="https://suments.com/" target="_blank">
                                    <img width="25%"
                                        src="<?php echo esc_attr(esc_url(plugins_url($this->Metawash)));?>/metawash/admin/img/company-logo.png"
                                        title="Metawash logo" width="15%">
                                </a>
                            </div>
                            <br>
							  <div class="card-mc-primary" style="margin-left:-5px;border-radius:25px;display:<?php echo ($this->s_token_get() == "") ?  'inline-block':'none;'?> ;">
                                <div class="container">
                                    <h3 class="text-white-mc"> 🗳 &nbsp;Si aún no lo has hecho, registra tu dominio en <a href="https://www.metawash.me/" class="text-white-mc">
                                       www.metawash.me</a> para obtener tu token.</h3>
                                </div>
							</div>
							     <br>
                            <div class="static-text border-style col_right">

                                <h2 style="display: inline-block;">Introduce aquí tu token</h2>&nbsp;
                                <a href="https://suments.com/es/metacleaner-como-obtengo-un-token/" target="_blank"
                                    class="text-primary">¿Cómo obtengo un token?</a><br>


                                <form action="" method="post" name="token_save">
                                    <input type="text" class="mc" id="mc_token" maxlength="32"
                                        placeholder="<?php echo ($this->s_token_get() == "") ? "Copia tu token aquí": $this->s_token_get();?>"
                                        value="<?php echo $this->s_token_get();?>" required>
                                    <input type="hidden" name="action" value="mc_send_token"
                                        style="display: none; visibility: hidden; opacity: 0;">
                                    <button id="mc_ajax_save_token" class="button-21" type="submit">Guardar token</button>
                                </form>
                                <div id="token_error_empty" style="display:none;margin-top:5px;" class="text-error-mc">
                                    <p class="text-error-mc"> Ups... parece que se te ha olvidado el token. </p>
                                </div>
								<div id="token_error_length" style="display:none;margin-top:5px;" class="text-error-mc">
                                    <p class="text-error-mc"> Vaya, la longitud del token parece incorrecta. ¿Lo has copiado bien?</p>
                                </div>
								<div id="mc_token_invalid" class="text-error-mc"
									style="display:<?php echo ($feedback_user['token_information']->valid == false) ? 'inline-block':'none;'?> ;margin-top:5px;">
                                    <p class="text-error-mc"> Vaya... parece que no es válido. </p>
								</div>
								<div id="token_saved_success" style="display:none;margin-top:5px;" class="text-success-mc">
                                    <p class="text-success-mc"> Todo ha ido como la seda :)</p>
                                </div>
                                <h4 class="text-primary" id="mc_token_valid" style="display:<?php echo ($this->s_token_get() == "") ?  'none':'inline-block;'?> ;">
                                    ✔ Token válido hasta
                                    <?php echo $feedback_user["token_information"]->date_expiration;?></h4>
                                
                                <h4 id="mc_token_plan" class="text-secondary" style="display:inline-block;">
                                    ☆ Plan actual: <?php echo $feedback_user["token_information"]->plan_name;?></h4>
									<a href=" https://suments.com/es/metacleaner/" target="_blank" class="text-primary">Ver planes</a>



                                <div id="token_saved_validation" style="display:none;" class="text-error-mc">
                                    <p class="text-error-mc"> Este token ha caducado. <br>
                                        Mientras no se renueve, vamos a utilizar la funcionalidad del plan gratuito.
                                        Más
                                        info en: <a href:"https://www.suments.com" target="_blank">aquí</a></p>
                                </div>
                                <div id="token_saved_fail" style="display:none;" class="text-error-mc">
                                    <p class="text-error-mc">
                                        Ups... algo fue mal. Intentalo de nuevo en unos minutos <br>
                                        Si el fallo persiste, puedes contactar con nosotros en <b><a
                                                href="mailto:hola@metacleaner.suments.com"
                                                target="_blank">hola@metacleaner.suments.com</a></b>
                                    </p>
                                </div>
                            </div>
							<br>
                            <hr />
                            <br>
                            <h1 class="wp-heading-inline" style="display:inline-block;"><b>Configuración</b>
							</h1>

							<div>
								<!-- Rounded switch -->
								<label class="switch">
									<input type="checkbox" id="config_auto" <?php echo ($this->s_config_auto_get() == "1") ?  " checked": " "?> >
									Limpiar archivos automáticamente al añadirlos. Esta opción funciona utilizando el gestor multimedia de Wordpress.
								
								</label>

							</div>

                            <br>
                            <hr />
                            <br>
                            <h1 class="wp-heading-inline" style="display:inline-block;"><b>Limpiador de archivos manual</b>
                            </h1>&nbsp;
                            <a href="https://suments.com/es/metacleaner-como-obtengo-un-token/" target="_blank"
                                class="text-primary">¿Cómo limpio mis archivos?</a>
                            <div>
                                <select name="directory" id="directory"
                                    style="width:60%; border-radius: 100px; border: 3px solid var(--secondary-color);">
                                    <option value="not_valid">Selecciona un directorio</option>
                                    <option value="all">TODOS LOS ARCHIVOS</option>
                                    <option value="not_valid"></option>
                                    <?php
									$nonce = wp_create_nonce("dirFilesCon_nonce");
									$directoriesSubdirectories = $this->getDirectories();
									foreach ($directoriesSubdirectories as $current_pair => [$subdirectory, $nfile]) { ?>
                                    <option value="<?php echo $subdirectory?>">
                                        <?php echo $subdirectory ." (".$nfile ." carpetas/archivos en total)"?></option>
                                    <?php  }   ?>
                                </select>
                                <input type="button" id="convert" class="button-secondary-mc action"
                                    value="🧹  Limpiar archivos" data-nonce="<?php echo $nonce ?>">
                            </div>

                            <div class="errorlog">
                                <h3>
                                </h3>
                                <span class="error">
                                </span>
                            </div>
                            <div id="mc_processing_gif" style="display:none;">
                                <h3 class="text-primary" style="font-style:italic;">Estamos limpiando los
                                    metadatos de
                                    tus
                                    archivos
                                </h3>
                                <img
                                    src="
                                    <?php echo esc_attr(esc_url(plugins_url($this->Metawash)));?>/metawash/admin/img/loading.gif" />
                            </div>
                            <!-- JAVI AQUÍ FALTA LA FUNCIÓN MOSTRAR/OCULTAR ESTE AVISO-->
								<br>
                            <div class="card-mc-alert" id="mc_traffic_exceeded_notice" style="display:none;">
                                <div class="container">
                                    <h3> ¡Ops! Has sobrepasado el límite de tráfico. </h3>
                                    <a href="https://www.suments.com/metacleaner/" class="text-primary">Actualiza a
                                        un
                                        plan
                                        superior
                                        para
                                        poder limpiar todos los archivos.</a>
                                </div>
                            </div>
                    
                            <div class="Fileslog">
                                <table id="mc_log_summary" class="paginated table table-bordered"
                                    style="display:none; width:100%; background-color:#f7fcfc;padding:10px;">
                                    <tr>
                                        <th style=" width:30%">
                                            <p class="text-success-mc log_success_n"></p>
                                        </th style="width:42%">
                                        <th>
                                            <p class="text-error-mc log_filesize_n"></p>
                                        </th>
                                        <th style="width:26%">
                                            <p class="text-error-mc log_extension_n"></p>
                                        </th>
                                    </tr>
                                    <tr>
                                        <td style="width:30%">
                                            <p class="text-success-mc log_success_files"></p>
                                        </td>
                                        <td style="width:42%">
                                            <p class="text-error-mc log_filesize_files"></p>
                                        </td>
                                        <td style="width:26%">
                                            <p class="text-error-mc log_extension_files"></p>
                                        </td>
                                    </tr>

                                    <tbody id="tabldata"></tbody>
                                </table>
                            </div>

                            <br>
                            <!-- INFORMACIÓN -->

                            <div>
                                <div>
                                    <b>
                                        <h5 class="text-success-mc" style="size: 20px;">
                                            <?php echo array_key_exists("ot", $feedback_user) ? $feedback_user["ot"]: "";?>

                                        </h5>
                                    </b>
                                </div>
                                <div class="tooltip">
                                    <h4 class="text-secondary">● Extensiones de archivos que tienen soporte:</h4>
                                    <h4> <?php echo implode(", ", $this->s_ft_get());?>
                                    </h4>
                                </div>
                                <br>
								<br>
                            <hr />
                            <br>
                            <h1 class="wp-heading-inline" style="display:inline-block;"><b>Contacto y soporte</b>
							</h1>
							
							<div>
								Si tienes algún problema, contacta con nosotros en <a href="mailto:hola@suments.com">hola@suments.com</a>
							</div>
							
                                <div>
                                    <!--<br>--------SECCION VERSION PARA NOSOTROS----------<br>-->
                                    <div class="wrap">
                                        <b>
                                            <h4 class="text-primary"> ✌
                                        </b> Versión: <?php echo $this->s_version_get_local();?>
                                        </h4>
                                    </div>
                                    <br><br>
                                    <p style="margin:0;font-size:14px;line-height:20px;">&copy; 2021 <a
                                            href="https://suments.com/" target="_blank">Suments
                                            Data</a>, We speak data! <br></p>

                                </div>
                            </div>

                            <!-- FIN INFORMACIÓN -->
                        </div>
                    </div>
                    <br>

                    <!-- FIN FUNCIONALIDAD -->
                </div>

        </td>
    </tr>
</table>
<?php



}

	public function getDirectories()
	{
		$path_target = WP_CONTENT_DIR . '/uploads/';
		$directories = [];
		$filecount = 0;
		$seen = [];
		foreach (new RecursiveIteratorIterator (new RecursiveDirectoryIterator ($path_target)) as $x){

			if (is_dir($x->getPathname())){
								
				$name = str_replace($path_target, "", $x->getPathname());

				if ($name != "/uploads/." || $name != "/uploads/.."){
					$name = str_replace("/..", "", $name);
					$name = str_replace("/.", "", $name);

					if (!in_array($name, $seen)){
						$filecount = count( glob($x->getPathname() ."/*" ));
						array_push($seen, $name);	
						array_push($directories, [$name, $filecount]);
					}					
				}
			}
		}
		return array_slice($directories, 2);
	}

	public function config_update_automatic(){
	
		$current = $this->s_config_auto_get();

		if ($current == "0"){
			$this->s_config_auto_set("1");
		} else{
			$this->s_config_auto_set("0");
		}	
		echo "CACACACACACA";
		die();
	}
	

	public function directory_files_connvert()
	{
		$this->s_stream_set_params();
		$plan_limits = $this->s_plan_limits_get();

		$plan_limits->consumed = intval($plan_limits->consumed);
		$plan_limits->filesize = intval($plan_limits->filesize);
		$plan_limits->traffic = intval($plan_limits->traffic);

		$ft = $this->s_ft_get();
		$log_process = [
			"extension_not_supported" => [],
			"filesize_exceeded" => [],
			"traffic_exceeded" => [],
			"success" => [],
			"user_plan" => $plan_limits,
		];

		$path_taget = ($_POST['directory'] == "all") ? WP_CONTENT_DIR.'/uploads/' : WP_CONTENT_DIR.'/uploads/'.$_POST['directory'];
		foreach (new RecursiveIteratorIterator (new RecursiveDirectoryIterator ($path_taget)) as $x)
		{
			if (!is_file($x->getPathname())){
				continue;
			}
			
			$fileInfo = pathinfo($x->getPathname());
			//echo "fileextension:  ".  strtoupper($fileInfo["extension"]) ;
			if (!in_array( strtoupper( $fileInfo["extension"] ), $ft)){
				array_push($log_process["extension_not_supported"], str_replace(WP_CONTENT_DIR, "", $x->getPathname()));
				continue;
			}

			$filesize = filesize($x->getPathname());
			if ( $filesize > $plan_limits->filesize){
				array_push($log_process["filesize_exceeded"],str_replace(WP_CONTENT_DIR, "", $x->getPathname()));
				continue;
			}
			
			if ($plan_limits->consumed > $plan_limits->traffic){
				array_push($log_process["traffic_exceeded"], str_replace(WP_CONTENT_DIR, "", $x->getPathname()));
				break;
			}
			$plan_limits->consumed = $plan_limits->consumed + $filesize;
			
			$this->apiCall_debug($x->getPathname(), $fileInfo["extension"]);
			array_push($log_process["success"], str_replace(WP_CONTENT_DIR, "", $x->getPathname()));
		}
		
		$json_data = json_encode($log_process);
		$this->s_log_results($json_data);
		echo $json_data;
		die();

	}

	private function s_log_results($results){
		file_put_contents($this->S_PATH_LOGS, $results);
	}

	public function apiCall_debug($filename, $fileext){
		$fp = fsockopen($this->S_URL_TARGET, 443, $errno, $errstr, 30);
		if (!$fp)                                                      
		{	
			echo "$errstr ($errno)<br />\n";
		}
		$file=fopen($filename,'rb');   
		$vars = array(
			'file' => '',
			'token' => $this->s_token_get(),
			'filename'=> $filename,
			'ext' => $fileext
		);
		$l = fread($file,1);           
		while(strlen($l) !== 0)        
			{
				$vars['file'] .= $l;   
				$l = fread($file,1024);
			}

		$content = http_build_query($vars);
		fwrite($fp, "POST ".$this->S_URL_POST." HTTP/1.1\r\n");
		fwrite($fp, "Host: ".$this->S_URL_HOST."\r\n");
		fwrite($fp, "Content-Type: application/x-www-form-urlencoded\r\n");
		fwrite($fp, "Content-Length: ".strlen($content)."\r\n"); 
		fwrite($fp, "Connection: close\r\n");
		fwrite($fp, "\r\n");
		fwrite($fp, $content);
		header('Content-type: text/plain');
		
		while (!feof($fp))  
		{
			$input = fgets($fp);     
			if($input == "Start\n")  
			{                        
				$input = '';         
				break;
			} 
		}
		unlink($filename);           
		$fout = fopen($filename,'x');
		$output ='';                 
		while (!feof($fp))           
			{
			$output .= fgets($fp);   
			}
		fwrite($fout,$output,strlen($output)); 
		#sleep(1);
		fclose($fp);                 
		fclose($fout);               
		chmod($filename, 0666);
		
	}

	public function mc_catch_uploaded($array){

		if ($this->s_config_auto_get() == "0"){
			return false;
		}

		if ( empty($array['file']))
			return false;

		$this->mc_local($array);

		return $array;
	}

	private function mc_local($array)
	{
		$fileInfo = pathinfo($array['file']);
				
		$filePath = $fileInfo['dirname'] . '/'.$fileInfo['basename'];
		$extension = $fileInfo['extension'];
		
		
		
		return 	$this->mc_local_clear($filePath, $extension);
	}

	private function mc_local_clear($imagePath, $extension){
		$extension = strtoupper($extension);
		$token_validation = $this->s_token_validate();
		
		if($token_validation->plan_name == "free"){
			if ( $extension != 'JPG' && $extension != 'JPEG' && $extension != 'PNG' && $extension != 'GIF'){	
				return $imagePath;
			}
		}
		
		$this->s_stream_set_params();
		$this->apiCall_debug($imagePath, $extension);
		chmod($imagePath, 0666);
		return $imagePath;

	}


	public function mc_save_token(){

		$this->s_token_set($_POST['input_token']);
	}

	private function s_stream_set_params(){
		$url = $this->S_URL_PREFIX."/mc_ur_get_params";
		$stream_params = $this->s_api_call_generic($url)->payload;
		$this->S_URL_POST = $stream_params->post;
		$this->S_URL_TARGET = $stream_params->target;
		$this->S_URL_HOST = $stream_params->host;
		return;
	}

	private function s_version_get_remote(){
		$url = $this->S_URL_PREFIX."/mc_current_version";
		return  $this->s_api_call_generic($url)->payload->version;
	}

	private function s_version_get_local(){
		return  file_get_contents($this->S_PATH_VERSION);
	}

	private function s_plan_limits_get(){
		$url = $this->S_URL_PREFIX."/mc_plan_limits";
		$data = array("rup" => $this->s_token_get());
		return $this->s_api_call_generic($url, $data)->payload;
	}

	private function s_ft_get(){
		$ft = file_get_contents($this->S_PATH_FT);

		return explode(",", $ft);

	}

	private function s_ft_update(){
		$url = $this->S_URL_PREFIX."/mc_files_supported";
		//echo $url;
		
		$tmp = "";
		$tmp_ft = "";
		foreach(  $this->s_api_call_generic($url)->payload->ft as $current){
			$current = str_replace(".", "", $current);

			$tmp_ft = $tmp_ft . strtoupper($current).",";
		}
		file_put_contents($this->S_PATH_FT, substr($tmp_ft, 0, -1) );
		return ;
	}

	private function s_api_call_generic($url, $data = false, $method="POST")	{
		$curl = curl_init();

		$data["token"] = $this->s_token_get();
		
		switch ($method)
		{
			case "POST":
				curl_setopt($curl, CURLOPT_POST, 1);
				curl_setopt($curl, CURLOPT_POSTFIELDS, $data);
				break;
			case "PUT":
				curl_setopt($curl, CURLOPT_PUT, 1);
				break;
			default:
				if ($data)
					$url = sprintf("%s?%s", $url, http_build_query($data));
		}

		curl_setopt($curl, CURLOPT_HTTPAUTH, CURLAUTH_BASIC);
		curl_setopt($curl, CURLOPT_URL, $url);
		curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);

		$result = curl_exec($curl);

		curl_close($curl);
		return json_decode($result);
	}

	private function s_token_validate(){
		
		$url = $this->S_URL_PREFIX."/mc_token_validate";
		$token_info = $this->s_api_call_generic($url, $data)->payload;
		return $token_info;

	}

	private function s_token_get(){
		return file_get_contents($this->S_PATH_TOKEN);
	}

	private function s_token_set($token){
		return file_put_contents($this->S_PATH_TOKEN, $token);
	}

	private function s_config_auto_get(){
		return file_get_contents($this->S_PATH_CONFIG_AUTO);
	}

	private function s_config_auto_set($value){
		return file_put_contents($this->S_PATH_CONFIG_AUTO, $value);
	}

}